//-----------------------------------------------------------------------------
//     The confidential and proprietary information contained in this file may
//     only be used by a person authorised under and to the extent permitted
//     by a subsisting licensing agreement from ARM Limited or its affiliates.
//
//            (C) COPYRIGHT 2015-2019 ARM Limited or its affiliates.
//                ALL RIGHTS RESERVED
//
//     This entire notice must be reproduced on all copies of this file
//     and copies of this file may only be made by a person if such person is
//     permitted to do so under the terms of a subsisting license agreement
//     from ARM Limited or its affiliates.
//
//     Release Information : ENYO-MP096-r1p0-00eac0
//
//-----------------------------------------------------------------------------
// SystemVerilog (IEEE Std 1800-2012)
//-----------------------------------------------------------------------------




`include "enyo_header.sv"


module enyo_vx_sha1su1
(


  input wire [127: 0]   qd,
  input wire [127:32]   qn,

  output wire [127:0]   d 
);







  wire [127:0]                           t;

assign t[127:0] = qd[127:0] ^ {{32{1'b0}},qn[127:32]};
assign d[127:96] = {t[126:96], t[127]} ^ {t[29:0], t[31:30]}; 
assign d[95:64] = {t[94:64], t[95]};
assign d[63:32] = {t[62:32], t[63]};
assign d[31:0]  = {t[30:0],  t[31]};

endmodule


`define ENYO_UNDEFINE
`include "enyo_header.sv"
`undef ENYO_UNDEFINE
